
<script>

import { onMount, onDestroy, beforeUpdate } from 'svelte'
import { ask_for_freight } from '$lib/Behavior/Trucks'
import { filter_trends_by_name } from '$lib/trends/filter/by_name'
import { filter_trends_by_similar } from '$lib/trends/filter/by_similarities'
import { ask_trend_count } from '$lib/mongo/trends/ask_count.mongo.js'

import { InputChip } from '@skeletonlabs/skeleton';

import { ask_trend_to_treasure } from '$lib/mongo/trends/ask_trend_to_treasure.mongo.js'
import { has_field } from 'procedures/object/has_field'
import { getModalStore } from '@skeletonlabs/skeleton';
import { Toast, getToastStore } from '@skeletonlabs/skeleton';

const toastStore = getToastStore();

let original_trends = [];
let trends = []

let sort_by = [];
$: {
	let _sort_by = sort_by;
	filter_sort ();
}

function toggle (_flavor) {
	let kind = _flavor [0]
	let direction = _flavor [1]
	
	console.log ("toggle:", _flavor)
		
	for (let index = 0; index < sort_by.length; index++) {
		if (sort_by [index] [0] == kind) {
			if (sort_by [index] [1] == direction) {
				sort_by.splice (index, 1);
				sort_by = [ ...sort_by ];
				console.log ({ sort_by });
				return;
			}
			else {
				return;
			}
		}		
	}
	
	
	sort_by.push ([
		kind, _flavor [1]
	])
	sort_by = [ ...sort_by ];
	
	
	console.log ({ sort_by });
}

let filter_sort = () => {
	let these_trends;
	
	trends = filter_trends_by_name ({ name_filter, trends: original_trends });
	trends = filter_trends_by_similar ({ similarities_filter, trends: trends });
	
	for (let index = 0; index < sort_by.length; index++) {
		if (sort_by [index] [0] === "domain") {
			if (sort_by [index] [1] === "ascending") {
				trends.sort ((a, b) => {
					if (a.domain < b.domain) return -1;
					if (a.domain > b.domain) return 1;
					return 0;
				});
			}
			else if (sort_by [index] [1] === "descending") {
				trends.sort ((a, b) => {
					if (a.domain < b.domain) return 1;
					if (a.domain > b.domain) return -1;
					return 0;
				});
			}
		}		
	}
	
}


let name_filter = "";
$: {
	let _name_filter = name_filter;
	filter_sort ();
}

let similarities_filter = "";
$: {
	let _similarities_filter = similarities_filter;
	filter_sort ();
}

const build = async () => {
	original_trends = []
	const { enhanced } = await ask_trend_count ()
	original_trends = enhanced.trends;
	filter_sort ();
}

onMount (async () => {
	build ();
})

const move_to_treasures = ({ trend }) => {
	return async () => {
		console.log ("trend", trend);
		
		const { enhanced, status } = await ask_trend_to_treasure ({
			domain: "domain.1"
		});
		
		console.info ({ status });
		
		build ();
	}
}

import Deletion_Modal from './Deletion_Modal.svelte';

const modal_store = getModalStore ()

const delete_trend = ({ trend }) => {	
	return async () => {
		console.log ("ask to delete trend", trend);

		modal_store.trigger ({
			type: 'component',
			title: 'Please Confirm',
			
			meta: {
				domain: trend.domain,
				after: () => {
					console.log ("after");
					
					modal_store.clear ()

					toastStore.trigger ({
						message: 'Perhaps was deleted..',
					});
				}
			},
			
			component: {
				ref: Deletion_Modal
			}
		});
	}
}



</script>


<div>
	<div class="card p-4">
		<label class="label">
			<span>Name Filter</span>
			<input 
				style="
					padding: 0.1cm 0.5cm;
				"
				class="input" type="text" 
				placeholder=""
				bind:value={ name_filter }
			/>
		</label>
	</div>
	
	<div style="height: 10px"></div>
	
	<div class="card p-4">
		<label class="label">
			<span>Similar Filter</span>
			<input 
				style="
					padding: 0.1cm 0.5cm;
				"
				class="input" type="text" 
				placeholder=""
				bind:value={ similarities_filter }
			/>
		</label>
	</div>
	
	<div style="height: 10px"></div>
	
	<div class="card p-4">
		sort_by: { sort_by }
	
		<div>
			<button 
				class="chip variant-soft hover:variant-filled" 
				on:click={() => { toggle ([ "domain", "ascending" ]) }}
			>
				<span>Domain Ascending</span>
			</button>
			
			<button 
				class="chip variant-soft hover:variant-filled"
				on:click={() => { toggle ([ "domain", "descending" ]) }}
			>
				<span>Domain Decending</span>
			</button>
			
			
		</div>
	</div>
	
	{#each trends as trend }
		<div style="display: none">{ JSON.stringify (trend, null, 4) }</div>
		<div
			class="card"
			style="
				margin: 12px 0;
				padding: 12px;
				
				display: flex;
				align-items: top;
				justify-content: center;
				
				flex-direction: row;
			
				gap: 4px;
			"
		>
			<div
				style="
					display: flex;
					flex-direction: column;
					
					gap: 6px;
					
					width: 100%;
				"
			>
				<div>
					<span class="badge variant-soft">
						<span>domain</span>
						<span class="badge variant-filled">{ trend.domain }</span>
					</span>
				</div>
				
				<div>
					<span class="badge variant-soft-warning">
						<span>names</span>
						{#if Array.isArray (trend.names) && trend.names.length >= 1}
						{#each trend.names as name }
							<span class="badge variant-filled">{ name }</span>
						{/each}
						{/if}
					</span>
				</div>
				
				<div>
					<span class="badge variant-soft-warning">
						<span>cautions</span>
						{#if Array.isArray (trend.cautions) && trend.cautions.length >= 1}
						{#each trend.cautions as caution }
							<span class="badge variant-filled-warning">{ caution }</span>
						{/each}
						{/if}
					</span>
				</div>
				
				<div>
					<span class="badge variant-soft">
						<span>similar</span>
						{#if Array.isArray (trend.similar) && trend.similar.length >= 1}
						{#each trend.similar as similarity }
							<span class="badge variant-filled">{ similarity }</span>
						{/each}
						{/if}
					</span>
				</div>
				
				{#if typeof trend.novella === "string" }
				<span class="badge variant-soft">
					<span>novella</span>
					<span class="badge variant-filled">{ trend.novella }</span>
				</span>
				{/if}
			</div>
			
			<div 
				style="
					margin: 4px 0;
					height: 100%;
					width: 4px;
					background: rgb(var(--color-surface-300);
					border-radius: 50px;
				"
			/>
			
			
			<div
				style="
					display: flex;
					flex-direction: column;
					justify-content: top;
					align-items: top;
					
					gap: 6px;
					
					width: 100%;
					height: 100%;
				"
			>
				<div
					style="
						text-align: right;
					"
				>
					<button 
						disabled={ typeof trend.novella === "string" ? false : true }
					
						type="button" 
						class="btn btn-sm variant-filled"
						on:click={ move_to_treasures ({ trend }) }	
					>Move to Treasures</button>
				</div>
			
				<div
					style="
						text-align: right;
					"
				>
					<button 
						type="button" 
						on:click={ delete_trend ({ trend }) }	
						
						class="btn btn-sm variant-filled-error"
						
					>Delete</button>
				</div>
			</div>
		</div>
	{/each}
</div>